#{extends 'borderNG.html' /}
#{set 'titleHead'}
&{'doc.rincian_hps'}
#{/set}

<ol class="breadcrumb">
    <li><a href="@{BerandaCtr.index()}">&{'doc.home'}</a></li>
#{if isEdit}
    <li><a href="@{nonlelang.PaketPlCtr.index()}">&{'doc.daftar_paket'} </a></li>
    <li><a href="@{nonlelang.PengadaanLCtr.edit(pl.lls_id)}">&{'doc.edit_paket'}</a></li>
#{/if}
#{else}
    <li><a href="@{nonlelang.PengadaanLCtr.view(pl.lls_id)}">&{'doc.info_paket'}</a></li>
#{/else}
    <li class="active">&{'doc.rincian_hps'}</li>
</ol>
<div class="content" id="hps-content">
    <div id="alert"></div>
#{if editable}
    <table id="template" class="table table-sm">
        <tr>
            <th>
                <a href="#{assets '/documents/template-rincian.xlsx'/}" class="btn btn-secondary ">
                    <i class="fa fa-download"></i> Template Rincian HPS</a>
                <a class="btn btn-secondary " href="#" onclick="$('#rincian_upload').click()" id="uploadHPS">Upload Rincian HPS</a>
            </th>
            <th><input type="file" id="rincian_upload" class="form-control" style="display:none"
                       placeholder="&{'doc.upload_rincian_hps'}" #{if !editable} disabled #{/if}></th>
        </tr>
    </table>
#{/if}
    #{if editable }
    <div class="bs-callout bs-callout-info">
        <b>&{'doc.petunjuk_upload_rincian'}</b><br/>
        &{'doc.petunjuk_upload_rincian_1'}<br/>
        &{'doc.petunjuk_upload_rincian_2'}
        <br/><br/>
        <b>&{'doc.petunjuk_pengisian_hps_excel'}</b><br/>
        &{'doc.petunjuk_pengisian_hps_excel_1'}<br/>
        &{'doc.petunjuk_pengisian_hps_excel_2'}<br/>
        &{'doc.petunjuk_pengisian_hps_excel_3'}
        <br /><br />
        <b>&{'doc.petunjuk_hps_tabel'}</b><br />
        &{'doc.untuk_menambah_baris'}<br />
    </div>
    <div class="clearfix"></div>
    *{<div class="bs-callout bs-callout-info">
    &{'doc.untuk_menambah_baris'}
    </div>}*
    <div class="bs-callout bs-callout-info">
        &{'doc.bilangan_bulatkan_2'}
    </div>
    #{/if}
    <table style="border:none; margin:20px;">
        <tr>
            <th style="text-align:right">&{'doc.total_pagu'} :</th>
            <th id="total_hps" style="text-align:right">${paket.pkt_pagu.rupiah()}</th>
        </tr>
    </table>

    <div id="tbl-rincian" style="margin:20px;"></div>
    <div class="float-right">
        <table id="rekap" class="table table-sm" style="width:300px;margin-right:50px;">
            <tr>
                <th style="text-align:right">&{'doc.total_nilai'}</th>
                <th id="total_hps" style="text-align:right"></th>
            </tr>
        </table>
    </div>
    #{if isPp}
#{if !pl.pemilihan}
   *{ <div class="form-check-inline">
        <label><input type="checkbox" id="fixed" name="fixed" value="false" #{if !fixed} checked #{/if} #{if !editable}
                      disabled="disabled" #{/if}/>
            &{'doc.peserta_boleh_mengubah'}</label>
    </div>}*
#{/if}
    #{/if}
    <div class="clearfix"></div>
#{if editable}
    #{authenticityToken /}
    <button type="button" name="simpan" id="simpan" class="btn btn-success"><i class="fa fa-save"></i> &{'doc.btn_simpan'}</button>
#{/if}
    <a href="${backUrl}" class="btn btn-secondary "><i class="fa fa-arrow-circle-left fa-fw"></i> Kembali</a>
</div>

#{set 'css_custom' }
    #{if editable}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">
    #{/if}
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}


#{set 'custom_script'}
    #{if editable}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
    #{/if}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>

<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/jszip.js"></script>
<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/xlsx.min.js"></script>>

<script type="text/javascript">

    var data = ${data?.raw()};
    var interval = 2 * 60 * 1000; // 2 menit
    var total = 0;
    var fixed = true;
    var enableViewHps = ${enableViewHps};

    var X = XLSX;

    $(document).on('change', '#rincian_upload', function (e) {
        var files = e.target.files;
        var f = files[0];
        {
            var reader = new FileReader();
            var name = f.name;
            reader.onload = function (e) {
                var data = e.target.result;
                try {
                    var wb = X.read(data, {type: 'binary'});
                    process_wb(wb);
                }catch(err){
                    console.log(err);
                    alert("Format file HPS yang Anda upload tidak valid.");
                }
            };
            reader.readAsBinaryString(f);
        }
    });

    function process_wb(wb) {
	    var output = to_json(wb);
	    var res = output['rincian-hps'];
	    var obj = new Array();
	    for (i = 0; i < res.length; i++) {
		    var totalharga = 0;
		    var totalpajak = 0;

		    var item = replaceChar(res[i]['Jenis Barang/Jasa']);
		    var unit = replaceChar(res[i]['Satuan']);
		    var vol = res[i]['Vol'];
		    // var unit2 = replaceChar(res[i]['Satuan 2']);
		    // var vol2 = res[i]['Vol 2'];
		    var harga = Number(res[i]['Harga'].replace(/[^0-9\.-]+/g,""));
		    var pajak = res[i]['Pajak(%)'];
		    //var total_harga = totalharga;
		    var keterangan = replaceChar(res[i]['Keterangan']);

		    if (!parseInt(harga, 10)) {
			    harga = 0;
		    }

		    if (!parseInt(vol, 10)) {
			    vol = 0;
		    } else {
			    totalharga = vol * harga;
		    }

		    // if (!parseInt(vol2, 10)) {
			 //    //console.log("vol2 not null");
			 //    vol2 = 1;
		    // }
		    // if (vol2 > 0) {
			 //    //console.log("if 2 :"+parseInt(res[i][2], 10))
			 //    totalharga = vol * vol2 * harga;
		    // }

		    //pajak ga boleh null
		    if (!parseInt(pajak, 10)) {
			    totalpajak = 0;
		    }
		    if (pajak > 0) {
			    totalpajak = (pajak / 100) * totalharga;
			    totalharga += totalpajak;
		    }

		    obj.push({
			    item: item,
			    unit: unit,
			    vol: vol,
			    // unit2: unit2,
			    // vol2: vol2,
			    harga: harga,
			    pajak: pajak,
			    //asep:total to auto
			    //total_harga:res[i][7],
			    total_harga: totalharga,
			    keterangan: keterangan
		    })

	    }
	    if (invalid_rows.length > 0) {
			$('#alert').html('<div class="alert alert-danger">Invalid input number pada baris ke ' + formatArray(invalid_rows) + '. Mohon periksa kembali inputan Anda!</div>');
		}
	    data = obj;
	    $("#tbl-rincian").handsontable("loadData", obj);
	    summary();
    }

    function formatArray(arr) {
		var outStr = "";
		if (arr.length === 1) {
			outStr = arr[0];
		} else if (arr.length === 2) {
			outStr = arr.join(" dan ");
		} else if (arr.length > 2) {
			outStr = arr.slice(0, -1).join(", ") + ", dan " + arr.slice(-1);
		}
		return outStr;
	}

    function to_json(workbook) {
        var result = {};
        workbook.SheetNames.forEach(function (sheetName) {
            var roa = X.utils.sheet_to_row_object_array(workbook.Sheets[sheetName]);
            if (roa.length > 0) {
                result[sheetName] = roa;
            }
        });
        return result;
    }

    function replaceChar(str) {
	    var strs = "";
	    if(str != undefined)
		    strs += str;

	    return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
    }
    function summary() {
        var data = $("#tbl-rincian").data('handsontable').getData();
        var total_hps = 0;
        var total = 0;
        for (i = 0; i < data.length; i++) {
            if (data[i].total_harga)
                total += parseFloat(data[i].total_harga);
        }
	    if (total > 0) {
		    total_hps = parseFloat(total);
	    }
	    $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
    }

    if (data.length == 0) {
        for(var i=0;i<15;i++){
            data.push({item: "", unit: "", vol: 1, unit2: "", vol2: 1, harga: 0, pajak: 10, total_harga: 0, keterangan: ""});
        }
    }

    $("#tbl-rincian").handsontable({
        rowHeaders: true,
        dataSchema: {
            item: "",
            unit: "",
            vol: 1,
            unit2: "",
            vol2: 1,
            harga: 0,
            pajak: 10,
            total_harga: 0,
            keterangan: ""
        },
        data: data,
        #{if editable}
            contextMenu: {
                items: {
                    "row_above": {name: "Tambah Baris Diatas"},
                    "row_below": {name: "Tambah Baris Dibawah"},
                    "remove_row": {name: "Hapus Baris"},
                    "undo": {name: "Undo"},
                    "redo": {name: "Redo"}
                }
            },
        #{/if}
        columns: [{data: 'item', width: 200, title: 'Jenis Barang/Jasa'},
            {data: 'unit', width: 100, title: 'Satuan'},
            {data: 'vol', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol'},
            // {data: 'unit2', width: 100, title: 'Satuan 2'},
            // {data: 'vol2', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol 2'},
            {data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Harga'},
            {data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: 'Pajak (%)', dataSchema: 10},
            {data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Total'},
            {data: 'keterangan', width: 250, title: 'Keterangan'}],


        cells: function (row, col, prop) {
        	
            var cellProperties = {};
            #{if editable}
                if (col == 5) {
                    cellProperties.readOnly = true;
                }
                if (data[row] && (col == 2 || col == 3 || col == 4)) {
                    var total = 0;
                    if (data[row].vol <= 0)
                        data[row].vol = 1.0;
                   // if (row == 0)
                        //console.log(data[row])
                    if (data[row].harga > 0)
                        total = data[row].harga;
                    else
                        data[row].total_harga = 0;
                    if (data[row].vol > 0) {
                        data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
                        total = total * data[row].vol;
                    }
                    if (data[row].pajak > 0)
                        total = total + ((total * data[row].pajak) / 100);
                    else
                        data[row].pajak = 0;
                    if (total > 0) {
                        data[row].total_harga = rounded2Decimal(total);
                    }

                }
                if (data[row] && (col == 1 || col == 2 || col == 6)) {
                    data[row].item = replaceChar(data[row].item);
                    data[row].unit = replaceChar(data[row].unit);
                    data[row].keterangan = replaceChar(data[row].keterangan);
                }
            #{/if}
            #{else}
                cellProperties.readOnly = true;
            #{/else}
            return cellProperties;
        },
        afterChange: function (change, source) {
            console.log('after change')
            summary();
        },
        afterRemoveRow: function () {
            console.log('after remove row')
            summary();
        },
    });
    $("#fixed").on('change', function () {
        fixed = this.checked ? false : true;
    });
        #{if editable}
        $("#simpan").click(function () {
            autosave();
        });
        function autosave() {
            var postdata = $("#tbl-rincian").data('handsontable').getData();
            var token = $("input[name='authenticityToken']").val();
            $.ajax({
                url: '@{nonlelang.DokumenPlCtr.hpsSubmit(pl.lls_id)}',
                data: {"data": JSON.stringify(postdata), "fixed": fixed, "enableViewHps": enableViewHps, "authenticityToken": token},
                type: 'POST',
                success: function (res) {
                    if (res.result === 'ok')
                        $('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
                    else if (res.result.length > 0)
                        $('#alert').html('<div class="alert alert-danger">' + res.result + '</div>');
                    else
                        $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
                },
                error: function () {
                    $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan karena ada kendala jaringan/server</div>');
                }
            });
        }
        setInterval(autosave, interval);
        #{/if}
</script>
#{/set}